package ink.wgink.module.wechat.service.official.account;

import ink.wgink.module.wechat.enums.XmlEventTypeEnum;
import ink.wgink.module.wechat.pojo.dtos.official.account.OfficialAccountUserDTO;
import ink.wgink.module.wechat.pojo.pos.official.account.OfficialAccountUserPO;
import ink.wgink.module.wechat.pojo.vos.official.account.OfficialAccountUserVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: IOfficialAccountUserService
 * @Description: 公众号用户
 * @Author: wanggeng
 * @Date: 2021/4/28 6:15 下午
 * @Version: 1.0
 */
public interface IOfficialAccountUserService {

    /**
     * 新增用户
     *
     * @param officialAccountUserVO
     */
    void save(OfficialAccountUserVO officialAccountUserVO);

    /**
     * 修改状态
     *
     * @param openId
     * @param xmlEventTypeEnum
     */
    void updateStatus(String openId, XmlEventTypeEnum xmlEventTypeEnum);

    /**
     * 详情
     *
     * @param params
     * @return
     */
    OfficialAccountUserDTO get(Map<String, Object> params);

    /**
     * 详情
     *
     * @param appId
     * @param openId
     * @return
     */
    OfficialAccountUserDTO get(String appId, String openId);

    /**
     * 详情
     *
     * @param params
     * @return
     */
    OfficialAccountUserPO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param appId
     * @param openId
     * @return
     */
    OfficialAccountUserPO getPO(String appId, String openId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<OfficialAccountUserDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<OfficialAccountUserPO> listPO(Map<String, Object> params);

    /**
     * 分页
     *
     * @param page
     * @return
     */
    SuccessResultList<List<OfficialAccountUserDTO>> listPage(ListPage page);

}
